<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.hzya.frame.sysnew.organ.dao.impl.SysOrganDaoImpl">

    <resultMap id="get-SysOrganEntity-result" type="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        <result property="id" column="id" jdbcType="VARCHAR"/>
        <result property="organName" column="organ_name" jdbcType="VARCHAR"/>
        <result property="organCode" column="organ_code" jdbcType="VARCHAR"/>
        <result property="parentOrganId" column="parent_organ_id" jdbcType="VARCHAR"/>
        <result property="state" column="state" jdbcType="VARCHAR"/>
        <result property="company" column="company" jdbcType="VARCHAR"/>
        <result property="managerId" column="manager_id" jdbcType="VARCHAR"/>
        <result property="managerName" column="manager_name" jdbcType="VARCHAR"/>
        <result property="remark" column="remark" jdbcType="VARCHAR"/>
        <result property="sorts" column="sorts" jdbcType="INTEGER"/>
        <result property="create_user_id" column="create_user_id" jdbcType="VARCHAR"/>
        <result property="create_time" column="create_time" jdbcType="TIMESTAMP"/>
        <result property="modify_user_id" column="modify_user_id" jdbcType="VARCHAR"/>
        <result property="modify_time" column="modify_time" jdbcType="TIMESTAMP"/>
        <result property="sts" column="sts" jdbcType="VARCHAR"/>
        <result property="org_id" column="org_id" jdbcType="VARCHAR"/>
        <result property="companyId" column="company_id" jdbcType="VARCHAR"/>
    </resultMap>
    <!-- 查询的字段-->
    <sql id="SysOrganEntity_Base_Column_List">
        id
       ,organ_name 
        ,organ_code 
        ,parent_organ_id 
        ,state
        ,company 
        ,manager_id 
        ,remark 
        ,sorts 
        ,create_user_id 
        ,create_time 
        ,modify_user_id 
        ,modify_time 
        ,sts 
        ,org_id 
        ,company_id 
     </sql>
    <!--通过ID获取数据 -->
    <select id="entity_get" resultMap="get-SysOrganEntity-result">
        select
        a.id
       ,a.organ_name
        ,a.organ_code
        ,a.parent_organ_id
        ,a.state
        ,a.company
        ,a.manager_id
      ,	(	SELECT person_name from sys_person WHERE sts = 'Y' and  id = a.manager_id )as manager_name

        ,a.remark
        ,a.sorts
        ,a.create_user_id
        ,a.create_time
        ,a.modify_user_id
        ,a.modify_time
        ,a.sts
        ,a.org_id
        ,a.company_id
    from sys_organ a where a.id = #{ id } and a.sts='Y'
    </select>
    <!-- 查询 采用==查询 -->
    <select id="entity_list_base" resultMap="get-SysOrganEntity-result"
            parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        select
        <include refid="SysOrganEntity_Base_Column_List"/>
        from sys_organ
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="organName != null and organName != ''">and organ_name = #{organName}</if>
            <if test="organCode != null and organCode != ''">and organ_code = #{organCode}</if>
            <if test="parentOrganId != null and parentOrganId != ''">and parent_organ_id = #{parentOrganId}</if>
            <if test="state != null and state != ''">and state = #{state}</if>
            <if test="company != null and company != ''">and company = #{company}</if>
            <if test="managerId != null and managerId != ''">and manager_id = #{managerId}</if>
            <if test="remark != null and remark != ''">and remark = #{remark}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id = #{create_user_id}</if>
            <if test="create_time != null">and create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">and modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">and org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!-- 查询符合条件的数量 -->
    <select id="entity_count" resultType="Integer" parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        select count(1) from sys_organ
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="organName != null and organName != ''">and organ_name = #{organName}</if>
            <if test="organCode != null and organCode != ''">and organ_code = #{organCode}</if>
            <if test="parentOrganId != null and parentOrganId != ''">and parent_organ_id = #{parentOrganId}</if>
            <if test="state != null and state != ''">and state = #{state}</if>
            <if test="company != null and company != ''">and company = #{company}</if>
            <if test="managerId != null and managerId != ''">and manager_id = #{managerId}</if>
            <if test="remark != null and remark != ''">and remark = #{remark}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id = #{create_user_id}</if>
            <if test="create_time != null">and create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">and modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">and org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
    </select>

    <!-- 分页查询列表 采用like格式 -->
    <select id="entity_list_like" resultMap="get-SysOrganEntity-result"
            parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        select
        <include refid="SysOrganEntity_Base_Column_List"/>
        from sys_organ
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id like concat('%',#{id},'%')</if>
            <if test="organName != null and organName != ''">and organ_name like concat('%',#{organName},'%')</if>
            <if test="organCode != null and organCode != ''">and organ_code like concat('%',#{organCode},'%')</if>
            <if test="parentOrganId != null and parentOrganId != ''">and parent_organ_id like
                concat('%',#{parentOrganId},'%')
            </if>
            <if test="state != null and state != ''">and state like concat('%',#{state},'%')</if>
            <if test="company != null and company != ''">and company like concat('%',#{company},'%')</if>
            <if test="managerId != null and managerId != ''">and manager_id like concat('%',#{managerId},'%')</if>
            <if test="remark != null and remark != ''">and remark like concat('%',#{remark},'%')</if>
            <if test="sorts != null">and sorts like concat('%',#{sorts},'%')</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id like
                concat('%',#{create_user_id},'%')
            </if>
            <if test="create_time != null">and create_time like concat('%',#{create_time},'%')</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id like
                concat('%',#{modify_user_id},'%')
            </if>
            <if test="modify_time != null">and modify_time like concat('%',#{modify_time},'%')</if>
            <if test="sts != null and sts != ''">and sts like concat('%',#{sts},'%')</if>
            <if test="org_id != null and org_id != ''">and org_id like concat('%',#{org_id},'%')</if>
            <if test="companyId != null and companyId != ''">and company_id like concat('%',#{companyId},'%')</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!-- 查询列表 字段采用or格式 -->
    <select id="SysOrganentity_list_or" resultMap="get-SysOrganEntity-result"
            parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        select
        <include refid="SysOrganEntity_Base_Column_List"/>
        from sys_organ
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">or id = #{id}</if>
            <if test="organName != null and organName != ''">or organ_name = #{organName}</if>
            <if test="organCode != null and organCode != ''">or organ_code = #{organCode}</if>
            <if test="parentOrganId != null and parentOrganId != ''">or parent_organ_id = #{parentOrganId}</if>
            <if test="state != null and state != ''">or state = #{state}</if>
            <if test="company != null and company != ''">or company = #{company}</if>
            <if test="managerId != null and managerId != ''">or manager_id = #{managerId}</if>
            <if test="remark != null and remark != ''">or remark = #{remark}</if>
            <if test="sorts != null">or sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">or create_user_id = #{create_user_id}</if>
            <if test="create_time != null">or create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">or modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">or modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">or sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">or org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">or company_id = #{companyId}</if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString()  ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

    <!--新增所有列-->
    <insert id="entity_insert" parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity"
    >
        insert into sys_organ(
        <trim suffix="" suffixOverrides=",">
            <if test="id != null and id != ''">id ,</if>
            <if test="organName != null and organName != ''">organ_name ,</if>
            <if test="organCode != null and organCode != ''">organ_code ,</if>
            <if test="parentOrganId != null and parentOrganId != ''">parent_organ_id ,</if>
            <if test="state != null and state != ''">state ,</if>
            <if test="company != null and company != ''">company ,</if>
            <if test="managerId != null and managerId != ''">manager_id ,</if>
            <if test="remark != null and remark != ''">remark ,</if>
            <if test="sorts != null">sorts ,</if>
            <if test="create_user_id != null and create_user_id != ''">create_user_id ,</if>
            <if test="create_time != null">create_time ,</if>
            <if test="modify_user_id != null and modify_user_id != ''">modify_user_id ,</if>
            <if test="modify_time != null">modify_time ,</if>
            <if test="sts != null and sts != ''">sts ,</if>
            <if test="org_id != null and org_id != ''">org_id ,</if>
            <if test="companyId != null and companyId != ''">company_id ,</if>
            <if test="sts == null ">sts,</if>
        </trim>
        )values(
        <trim suffix="" suffixOverrides=",">
            <if test="id != null and id != ''">#{id} ,</if>
            <if test="organName != null and organName != ''">#{organName} ,</if>
            <if test="organCode != null and organCode != ''">#{organCode} ,</if>
            <if test="parentOrganId != null and parentOrganId != ''">#{parentOrganId} ,</if>
            <if test="state != null and state != ''">#{state} ,</if>
            <if test="company != null and company != ''">#{company} ,</if>
            <if test="managerId != null and managerId != ''">#{managerId} ,</if>
            <if test="remark != null and remark != ''">#{remark} ,</if>
            <if test="sorts != null">#{sorts} ,</if>
            <if test="create_user_id != null and create_user_id != ''">#{create_user_id} ,</if>
            <if test="create_time != null">#{create_time} ,</if>
            <if test="modify_user_id != null and modify_user_id != ''">#{modify_user_id} ,</if>
            <if test="modify_time != null">#{modify_time} ,</if>
            <if test="sts != null and sts != ''">#{sts} ,</if>
            <if test="org_id != null and org_id != ''">#{org_id} ,</if>
            <if test="companyId != null and companyId != ''">#{companyId} ,</if>
            <if test="sts == null ">'Y',</if>
        </trim>
        )
    </insert>
    <!-- 批量新增 -->
    <insert id="entityInsertBatch">
        insert into sys_organ(organ_name, organ_code, parent_organ_id, state, company, manager_id,
        remark, sorts, create_user_id, create_time, modify_user_id, modify_time, sts, org_id, company_id, sts)
        values
        <foreach collection="entities" item="entity" separator=",">
            (#{entity.organName},#{entity.organCode},#{entity.parentOrganId},#{entity.state},#{entity.company},#{entity.managerId},#{entity.remark},#{entity.sorts},#{entity.create_user_id},#{entity.create_time},#{entity.modify_user_id},#{entity.modify_time},#{entity.sts},#{entity.org_id},#{entity.companyId},
            'Y')
        </foreach>
    </insert>
    <!-- 批量新增或者修改-->
    <insert id="entityInsertOrUpdateBatch">
        insert into sys_organ(organ_name, organ_code, parent_organ_id, state, company, manager_id,
        remark, sorts, create_user_id, create_time, modify_user_id, modify_time, sts, org_id, company_id)
        values
        <foreach collection="entities" item="entity" separator=",">
            (#{entity.organName},#{entity.organCode},#{entity.parentOrganId},#{entity.state},#{entity.company},#{entity.managerId},#{entity.remark},#{entity.sorts},#{entity.create_user_id},#{entity.create_time},#{entity.modify_user_id},#{entity.modify_time},#{entity.sts},#{entity.org_id},#{entity.companyId})
        </foreach>
        on duplicate key update
        organ_name = values(organ_name),
        organ_code = values(organ_code),
        parent_organ_id = values(parent_organ_id),
        state = values(state),
        company = values(company),
        manager_id = values(manager_id),
        remark = values(remark),
        sorts = values(sorts),
        create_user_id = values(create_user_id),
        create_time = values(create_time),
        modify_user_id = values(modify_user_id),
        modify_time = values(modify_time),
        sts = values(sts),
        org_id = values(org_id),
        company_id = values(company_id)
    </insert>
    <!--通过主键修改方法-->
    <update id="entity_update" parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        update sys_organ set
        <trim suffix="" suffixOverrides=",">
            <if test="organName != null and organName != ''">organ_name = #{organName},</if>
            <if test="organCode != null and organCode != ''">organ_code = #{organCode},</if>
            <if test="parentOrganId != null and parentOrganId != ''">parent_organ_id = #{parentOrganId},</if>
            <if test="state != null and state != ''">state = #{state},</if>
            <if test="company != null and company != ''">company = #{company},</if>
            <if test="managerId != null and managerId != ''">manager_id = #{managerId},</if>
            <if test="remark != null and remark != ''">remark = #{remark},</if>
            <if test="sorts != null">sorts = #{sorts},</if>
            <if test="create_user_id != null and create_user_id != ''">create_user_id = #{create_user_id},</if>
            <if test="create_time != null">create_time = #{create_time},</if>
            <if test="modify_user_id != null and modify_user_id != ''">modify_user_id = #{modify_user_id},</if>
            <if test="modify_time != null">modify_time = #{modify_time},</if>
            <if test="sts != null and sts != ''">sts = #{sts},</if>
            <if test="org_id != null and org_id != ''">org_id = #{org_id},</if>
            <if test="companyId != null and companyId != ''">company_id = #{companyId},</if>
        </trim>
        where id = #{id}
    </update>
    <!-- 逻辑删除 -->
    <update id="entity_logicDelete" parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
update sys_organ  set sts= 'N' ,modify_time = #{modify_time},modify_user_id = #{modify_user_id}
where id = #{id}
</update>
    <!-- 多条件逻辑删除 -->
    <update id="entity_logicDelete_Multi_Condition" parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        update sys_organ set sts= 'N' ,modify_time = #{modify_time},modify_user_id = #{modify_user_id}
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="organName != null and organName != ''">and organ_name = #{organName}</if>
            <if test="organCode != null and organCode != ''">and organ_code = #{organCode}</if>
            <if test="parentOrganId != null and parentOrganId != ''">and parent_organ_id = #{parentOrganId}</if>
            <if test="state != null and state != ''">and state = #{state}</if>
            <if test="company != null and company != ''">and company = #{company}</if>
            <if test="managerId != null and managerId != ''">and manager_id = #{managerId}</if>
            <if test="remark != null and remark != ''">and remark = #{remark}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            and sts='Y'
        </trim>
    </update>
    <!--通过主键删除-->
    <delete id="entity_delete">
    delete from sys_organ where id = #{id}
</delete>

    <!-- 查询 采用==查询 -->
    <select id="queryUserCompany" resultMap="get-SysOrganEntity-result"
            parameterType="com.hzya.frame.sysnew.organ.entity.SysOrganEntity">
        select
        <include refid="SysOrganEntity_Base_Column_List"/>
        from sys_organ
        <trim prefix="where" prefixOverrides="and">
            <if test="id != null and id != ''">and id = #{id}</if>
            <if test="organName != null and organName != ''">and organ_name = #{organName}</if>
            <if test="organCode != null and organCode != ''">and organ_code = #{organCode}</if>
            <if test="parentOrganId != null and parentOrganId != ''">and parent_organ_id = #{parentOrganId}</if>
            <if test="state != null and state != ''">and state = #{state}</if>
            <if test="company != null and company != ''">and company = #{company}</if>
            <if test="managerId != null and managerId != ''">and manager_id = #{managerId}</if>
            <if test="remark != null and remark != ''">and remark = #{remark}</if>
            <if test="sorts != null">and sorts = #{sorts}</if>
            <if test="create_user_id != null and create_user_id != ''">and create_user_id = #{create_user_id}</if>
            <if test="create_time != null">and create_time = #{create_time}</if>
            <if test="modify_user_id != null and modify_user_id != ''">and modify_user_id = #{modify_user_id}</if>
            <if test="modify_time != null">and modify_time = #{modify_time}</if>
            <if test="sts != null and sts != ''">and sts = #{sts}</if>
            <if test="org_id != null and org_id != ''">and org_id = #{org_id}</if>
            <if test="companyId != null and companyId != ''">and company_id = #{companyId}</if>
            <if test="userId != null and userId != ''">
                and id in (
                SELECT user_company_id FROM sys_user_company WHERE user_id = #{userId} and sts = 'Y'
                )
            </if>
            and sts='Y'
        </trim>
        <if test=" sort == null or sort == ''.toString() ">order by sorts asc</if>
        <if test=" sort !='' and sort!=null and order !='' and order!=null ">order by ${sort} ${order}</if>
    </select>

</mapper>

